c6c0b0022016c1667ce69e0246b2a73aa357d688
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.3-beta3"
28 GIT_BRANCH=master:master # Version number
29 SLOGAN="www.ipfire.org" # Software slogan
30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
31 NICE=10 # Nice level
32 MAX_RETRIES=1 # prefetch/check loop
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
35 GIT_TAG=$(git tag | tail -1)
36
37 IPFVER="full" # Which versions should be compiled? (full|devel)
38
39 # Debian specific settings
40 if [ ! -e /etc/debian_version ]; then
41 FULLPATH=`which $0`
42 else
43 if [ -x /usr/bin/realpath ]; then
44 FULLPATH=`/usr/bin/realpath $0`
45 else
46 echo "ERROR: Need to do apt-get install realpath"
47 exit 1
48 fi
49 fi
50
51 PWD=`pwd`
52 BASENAME=`basename $0`
53 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
54 LOGFILE=$BASEDIR/log/_build.preparation.log
55 export BASEDIR LOGFILE
56 DIR_CHK=$BASEDIR/cache/check
57 mkdir $BASEDIR/log/ 2>/dev/null
58
59 # Include funtions
60 . tools/make-functions
61
62 if [ -f .config ]; then
63 . .config
64 else
65 echo -e "${BOLD}No configuration found!${NORMAL}"
66 echo -ne "Do you want to create one (y/N)?"
67 read CREATE_CONFIG
68 echo ""
69 if [ "$CREATE_CONFIG" == "y" ]; then
70 make_config
71 fi
72 fi
73
74 if [ -z $EDITOR ]; then
75 for i in nano emacs vi; do
76 EDITOR=$(which $i 2>/dev/null)
77 if ! [ -z $EDITOR ]; then
78 export EDITOR=$EDITOR
79 break
80 fi
81 done
82 [ -z $EDITOR ] && exiterror "You should have installed an editor."
83 fi
84
85 prepareenv() {
86 ############################################################################
87 # #
88 # Are we running the right shell? #
89 # #
90 ############################################################################
91 if [ ! "$BASH" ]; then
92 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
93 fi
94
95 if [ -z "${BASH_VERSION}" ]; then
96 exiterror "Not running BASH shell."
97 fi
98
99
100 ############################################################################
101 # #
102 # Trap on emergency exit #
103 # #
104 ############################################################################
105 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
106
107
108 ############################################################################
109 # #
110 # Resetting our nice level #
111 # #
112 ############################################################################
113 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
114 renice $NICE $$ > /dev/null
115 if [ `nice` != "$NICE" ]; then
116 beautify message FAIL
117 exiterror "Failed to set correct nice level"
118 else
119 beautify message DONE
120 fi
121
122
123 ############################################################################
124 # #
125 # Checking if running as root user #
126 # #
127 ############################################################################
128 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
129 if [ `id -u` != 0 ]; then
130 beautify message FAIL
131 exiterror "Not building as root"
132 else
133 beautify message DONE
134 fi
135
136
137 ############################################################################
138 # #
139 # Checking for necessary temporary space #
140 # #
141 ############################################################################
142 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
143 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
144 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
145 if (( 2048000 > $BASE_ASPACE )); then
146 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
147 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
148 beautify message FAIL
149 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
150 fi
151 else
152 beautify message DONE
153 fi
154
155 ############################################################################
156 # #
157 # Building Linux From Scratch system #
158 # #
159 ############################################################################
160 # Set umask
161 umask 022
162
163 # Set LFS Directory
164 LFS=$BASEDIR/build
165
166 # Check /tools symlink
167 if [ -h /tools ]; then
168 rm -f /tools
169 fi
170 if [ ! -a /tools ]; then
171 ln -s $BASEDIR/build/tools /
172 fi
173 if [ ! -h /tools ]; then
174 exiterror "Could not create /tools symbolic link."
175 fi
176
177 # Setup environment
178 set +h
179 LC_ALL=POSIX
180 MAKETUNING="-j6"
181 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
182 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
183
184 # Make some extra directories
185 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
186 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
187 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
188 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
189
190 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
191 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
192
193 # Make all sources and proc available under lfs build
194 mount --bind /dev $BASEDIR/build/dev
195 mount --bind /dev/pts $BASEDIR/build/dev/pts
196 mount --bind /dev/shm $BASEDIR/build/dev/shm
197 mount --bind /proc $BASEDIR/build/proc
198 mount --bind /sys $BASEDIR/build/sys
199 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
200 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
201 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
202 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
203 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
204 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
205 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
206 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
207 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
208
209 # This is a temporary hack!!!
210 if [ ! -f /tools/bin/hostname ]; then
211 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
212 fi
213
214 # Run LFS static binary creation scripts one by one
215 export CCACHE_DIR=$BASEDIR/ccache
216 export CCACHE_HASHDIR=1
217
218 # Remove pre-install list of installed files in case user erase some files before rebuild
219 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
220 }
221
222 buildtoolchain() {
223 LOGFILE="$BASEDIR/log/_build.toolchain.log"
224 export LOGFILE
225 ORG_PATH=$PATH
226 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
227 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
228 lfsmake1 ccache
229 lfsmake1 binutils PASS=1
230 lfsmake1 gcc PASS=1
231 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
232 lfsmake1 linux-libc-header
233 lfsmake1 glibc
234 lfsmake1 cleanup-toolchain PASS=1
235 lfsmake1 tcl
236 lfsmake1 expect
237 lfsmake1 dejagnu
238 lfsmake1 gcc PASS=2
239 lfsmake1 binutils PASS=2
240 lfsmake1 ncurses
241 lfsmake1 bash
242 lfsmake1 bzip2
243 lfsmake1 coreutils
244 lfsmake1 diffutils
245 lfsmake1 findutils
246 lfsmake1 gawk
247 lfsmake1 gettext
248 lfsmake1 grep
249 lfsmake1 gzip
250 lfsmake1 m4
251 lfsmake1 make
252 lfsmake1 patch
253 lfsmake1 perl
254 lfsmake1 sed
255 lfsmake1 tar
256 lfsmake1 texinfo
257 lfsmake1 util-linux
258 lfsmake1 cleanup-toolchain PASS=2
259 export PATH=$ORG_PATH
260 }
261
262 buildbase() {
263 LOGFILE="$BASEDIR/log/_build.base.log"
264 export LOGFILE
265 lfsmake2 stage2
266 lfsmake2 linux-libc-header
267 lfsmake2 man-pages
268 lfsmake2 glibc
269 lfsmake2 cleanup-toolchain PASS=3
270 lfsmake2 binutils
271 lfsmake2 gcc
272 lfsmake2 berkeley
273 lfsmake2 coreutils
274 lfsmake2 iana-etc
275 lfsmake2 m4
276 lfsmake2 bison
277 lfsmake2 ncurses
278 lfsmake2 procps
279 lfsmake2 sed
280 lfsmake2 libtool
281 lfsmake2 perl
282 lfsmake2 readline
283 lfsmake2 zlib
284 lfsmake2 autoconf
285 lfsmake2 automake
286 lfsmake2 bash
287 lfsmake2 bzip2
288 lfsmake2 diffutils
289 lfsmake2 e2fsprogs
290 lfsmake2 ed
291 lfsmake2 file
292 lfsmake2 findutils
293 lfsmake2 flex
294 lfsmake2 gawk
295 lfsmake2 gettext
296 lfsmake2 grep
297 lfsmake2 groff
298 lfsmake2 gzip
299 lfsmake2 inetutils
300 lfsmake2 iproute2
301 lfsmake2 kbd
302 lfsmake2 less
303 lfsmake2 libaal
304 lfsmake2 make
305 lfsmake2 man
306 lfsmake2 mktemp
307 lfsmake2 modutils
308 lfsmake2 mtd
309 lfsmake2 net-tools
310 lfsmake2 patch
311 lfsmake2 psmisc
312 lfsmake2 reiser4progs
313 lfsmake2 shadow
314 lfsmake2 sysklogd
315 lfsmake2 sysvinit
316 lfsmake2 tar
317 lfsmake2 texinfo
318 lfsmake2 udev
319 lfsmake2 util-linux
320 lfsmake2 vim
321 lfsmake2 grub
322 }
323
324 buildipfire() {
325 LOGFILE="$BASEDIR/log/_build.ipfire.log"
326 export LOGFILE
327 ipfiremake configroot
328 ipfiremake backup
329 ipfiremake dhcp
330 ipfiremake dhcpcd
331 ipfiremake libusb
332 ipfiremake libpcap
333 ipfiremake ppp
334 ipfiremake rp-pppoe
335 ipfiremake unzip
336 # ipfiremake linux SMP=1
337 # ipfiremake linux-fusion SMP=1
338 # ipfiremake ipp2p SMP=1
339 # ipfiremake r8169 SMP=1
340 # ipfiremake r8168 SMP=1
341 # ipfiremake atl2 SMP=1
342 # ipfiremake kqemu SMP=1
343 # ipfiremake v4l-dvb SMP=1
344 # ipfiremake madwifi SMP=1
345 # ipfiremake alsa KMOD=1 SMP=1
346 # ipfiremake sane KMOD=1 SMP=1
347 # ipfiremake openswan KMOD=1 SMP=1
348 ipfiremake linux
349 ipfiremake linux-fusion
350 ipfiremake ipp2p
351 ipfiremake r8169
352 ipfiremake r8168
353 ipfiremake atl2
354 ipfiremake kqemu
355 ipfiremake v4l-dvb
356 ipfiremake madwifi
357 ipfiremake alsa KMOD=1
358 ipfiremake sane KMOD=1
359 ipfiremake openswan KMOD=1
360 ipfiremake pkg-config
361 ipfiremake linux-atm
362 ipfiremake cpio
363 ipfiremake klibc
364 ipfiremake mkinitcpio
365 ipfiremake udev KLIBC=1
366 ipfiremake expat
367 ipfiremake gdbm
368 ipfiremake gmp
369 ipfiremake pam
370 ipfiremake openssl
371 ipfiremake curl
372 ipfiremake python
373 ipfiremake libnet
374 ipfiremake libidn
375 ipfiremake libjpeg
376 ipfiremake libpng
377 ipfiremake libtiff
378 ipfiremake libart
379 ipfiremake freetype
380 ipfiremake gd
381 ipfiremake popt
382 ipfiremake pcre
383 ipfiremake slang
384 ipfiremake newt
385 ipfiremake libcap
386 ipfiremake pciutils
387 ipfiremake usbutils
388 ipfiremake libxml2
389 ipfiremake libxslt
390 ipfiremake BerkeleyDB
391 ipfiremake mysql
392 ipfiremake cyrus-sasl
393 ipfiremake openldap
394 ipfiremake apache2
395 ipfiremake php
396 ipfiremake apache2 PASS=C
397 ipfiremake arping
398 ipfiremake beep
399 ipfiremake bind
400 ipfiremake cdrtools
401 ipfiremake dnsmasq
402 ipfiremake dosfstools
403 ipfiremake squashfstools
404 ipfiremake reiserfsprogs
405 ipfiremake xfsprogs
406 ipfiremake sysfsutils
407 ipfiremake fuse
408 ipfiremake ntfs-3g
409 ipfiremake ethtool
410 ipfiremake ez-ipupdate
411 ipfiremake fcron
412 ipfiremake perl-GD
413 ipfiremake GD-Graph
414 ipfiremake GD-TextUtil
415 ipfiremake gnupg
416 ipfiremake hdparm
417 ipfiremake sdparm
418 ipfiremake mtools
419 ipfiremake initscripts
420 ipfiremake whatmask
421 ipfiremake iptables
422 ipfiremake libupnp
423 ipfiremake ipp2p IPT=1
424 ipfiremake linux-igd
425 ipfiremake ipaddr
426 ipfiremake iptstate
427 ipfiremake iputils
428 ipfiremake l7-protocols
429 ipfiremake mISDN
430 ipfiremake capi4k-utils
431 ipfiremake hwdata
432 ipfiremake kudzu
433 ipfiremake logrotate
434 ipfiremake logwatch
435 ipfiremake misc-progs
436 ipfiremake nano
437 ipfiremake nasm
438 ipfiremake URI
439 ipfiremake HTML-Tagset
440 ipfiremake HTML-Parser
441 ipfiremake Compress-Zlib
442 ipfiremake Digest
443 ipfiremake Digest-SHA1
444 ipfiremake Digest-HMAC
445 ipfiremake libwww-perl
446 ipfiremake Net-DNS
447 ipfiremake Net-IPv4Addr
448 ipfiremake Net_SSLeay
449 ipfiremake IO-Stringy
450 ipfiremake Unix-Syslog
451 ipfiremake Mail-Tools
452 ipfiremake MIME-Tools
453 ipfiremake Net-Server
454 ipfiremake Convert-TNEF
455 ipfiremake Convert-UUlib
456 ipfiremake Archive-Tar
457 ipfiremake Archive-Zip
458 ipfiremake Text-Tabs+Wrap
459 ipfiremake Locale-Country
460 ipfiremake XML-Parser
461 ipfiremake glib
462 ipfiremake GeoIP
463 ipfiremake fwhits
464 ipfiremake noip_updater
465 ipfiremake ntp
466 ipfiremake openssh
467 ipfiremake rrdtool
468 ipfiremake setserial
469 ipfiremake setup
470 ipfiremake snort
471 ipfiremake oinkmaster
472 ipfiremake squid
473 ipfiremake squid-graph
474 ipfiremake squidguard
475 ipfiremake calamaris
476 ipfiremake tcpdump
477 ipfiremake traceroute
478 ipfiremake vlan
479 ipfiremake wireless
480 ipfiremake libsafe
481 ipfiremake pakfire
482 ipfiremake java
483 ipfiremake spandsp
484 ipfiremake lzo
485 ipfiremake openvpn
486 ipfiremake pammysql
487 ipfiremake cups
488 ipfiremake ghostscript
489 ipfiremake foomatic
490 ipfiremake hplip
491 ipfiremake samba
492 ipfiremake sudo
493 ipfiremake mc
494 ipfiremake wget
495 ipfiremake bridge-utils
496 ipfiremake screen
497 ipfiremake hddtemp
498 ipfiremake smartmontools
499 ipfiremake htop
500 ipfiremake postfix
501 ipfiremake fetchmail
502 ipfiremake cyrus-imapd
503 ipfiremake openmailadmin
504 ipfiremake clamav
505 ipfiremake spamassassin
506 ipfiremake amavisd
507 ipfiremake alsa
508 ipfiremake mpfire
509 ipfiremake guardian
510 ipfiremake libid3tag
511 ipfiremake libmad
512 ipfiremake libogg
513 ipfiremake libvorbis
514 ipfiremake libdvbpsi
515 ipfiremake lame
516 ipfiremake sox
517 ipfiremake libshout
518 ipfiremake icecast
519 ipfiremake icegenerator
520 ipfiremake mpd
521 ipfiremake mpc
522 ipfiremake xvid
523 ipfiremake libmpeg2
524 ipfiremake cmake
525 ipfiremake libpri
526 ipfiremake asterisk
527 ipfiremake gnump3d
528 ipfiremake libsigc++
529 ipfiremake applejuice
530 ipfiremake ocaml
531 ipfiremake mldonkey
532 ipfiremake libtorrent
533 ipfiremake rtorrent
534 ipfiremake ipfireseeder
535 ipfiremake rsync
536 ipfiremake tcpwrapper
537 ipfiremake portmap
538 ipfiremake nfs
539 ipfiremake nmap
540 ipfiremake ncftp
541 ipfiremake etherwake
542 ipfiremake bwm-ng
543 ipfiremake tripwire
544 ipfiremake sysstat
545 ipfiremake vsftpd
546 ipfiremake which
547 ipfiremake openswan
548 ipfiremake lsof
549 ipfiremake centerim
550 ipfiremake br2684ctl
551 ipfiremake pcmciautils
552 ipfiremake lm_sensors
553 ipfiremake collectd
554 ipfiremake lcd4linux
555 ipfiremake neon
556 ipfiremake tcptrack
557 ipfiremake teamspeak
558 ipfiremake elinks
559 ipfiremake igmpproxy
560 ipfiremake fbset
561 ipfiremake sdl
562 ipfiremake qemu
563 ipfiremake sane
564 ipfiremake netpbm
565 ipfiremake phpSANE
566 ipfiremake tunctl
567 ipfiremake nagios
568 ipfiremake ebtables
569 ipfiremake arptables
570 ipfiremake fontconfig
571 ipfiremake freefont
572 ipfiremake directfb
573 ipfiremake dfb++
574 ipfiremake ffmpeg
575 ipfiremake videolan
576 ipfiremake vdr
577 ipfiremake w_scan
578 ipfiremake git
579 ipfiremake squidclamav
580 ipfiremake bc
581 ipfiremake esniper
582 ipfiremake vnstat
583 ipfiremake vnstati
584 ipfiremake wpa_supplicant
585 ipfiremake hostapd
586 ipfiremake urlgrabber
587 ipfiremake syslinux
588 ipfiremake tftp-hpa
589 ipfiremake cpufrequtils
590 ipfiremake dbus
591 ipfiremake bluetooth
592 ipfiremake gutenprint
593 echo Build on $HOSTNAME > $BASEDIR/build/var/ipfire/firebuild
594 cat /proc/version >> $BASEDIR/build/var/ipfire/firebuild
595 echo >> $BASEDIR/build/var/ipfire/firebuild
596 git log -1 >> $BASEDIR/build/var/ipfire/firebuild
597 echo >> $BASEDIR/build/var/ipfire/firebuild
598 git status >> $BASEDIR/build/var/ipfire/firebuild
599 echo >> $BASEDIR/build/var/ipfire/firebuild
600 cat /proc/cpuinfo >> $BASEDIR/build/var/ipfire/firebuild
601 }
602
603 buildinstaller() {
604 # Run installer scripts one by one
605 LOGFILE="$BASEDIR/log/_build.installer.log"
606 export LOGFILE
607 ipfiremake as86
608 ipfiremake mbr
609 ipfiremake memtest
610 installmake linux-libc-header
611 installmake binutils
612 ipfiremake uClibc PASS=1
613 ipfiremake gcc INST=1
614 installmake uClibc PASS=2
615 installmake gcc INST=2
616 installmake uClibc PASS=3
617 installmake busybox
618 installmake udev
619 installmake slang
620 installmake newt
621 installmake gettext
622 installmake kbd
623 installmake popt
624 installmake sysvinit
625 installmake misc-progs
626 installmake libaal
627 installmake reiser4progs
628 installmake reiserfsprogs
629 installmake sysfsutils
630 installmake util-linux
631 installmake pciutils
632 installmake zlib
633 installmake mtd
634 installmake wget
635 installmake hwdata
636 installmake kudzu
637 installmake pcmciautils
638 installmake installer
639 installmake initrd
640 }
641
642 buildpackages() {
643 LOGFILE="$BASEDIR/log/_build.packages.log"
644 export LOGFILE
645 echo "... see detailed log in _build.*.log files" >> $LOGFILE
646
647 installmake strip
648
649 # Generating list of packages used
650 echo -n "Generating packages list from logs" | tee -a $LOGFILE
651 rm -f $BASEDIR/doc/packages-list
652 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
653 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
654 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
655 fi
656 done
657 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
658 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
659 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
660 rm -f $BASEDIR/doc/packages-list
661 # packages-list.txt is ready to be displayed for wiki page
662 beautify message DONE
663
664 # Update changelog
665 cd $BASEDIR
666 $0 git log
667
668 # Create images for install
669 ipfiremake cdrom ED=full
670
671 # Check if there is a loop device for building in virtual environments
672 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
673 ipfiremake usb-stick
674 fi
675
676 # Create updater package
677 ipfiremake updater
678 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
679
680 ipfirepackages
681
682 # Cleanup
683 stdumount
684 rm -rf $BASEDIR/build/tmp/*
685
686 # Generating total list of files
687 echo -n "Generating files list from logs" | tee -a $LOGFILE
688 rm -f $BASEDIR/log/FILES
689 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
690 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
691 echo "##" >>$BASEDIR/log/FILES
692 echo "## `basename $i`" >>$BASEDIR/log/FILES
693 echo "##" >>$BASEDIR/log/FILES
694 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
695 fi
696 done
697 beautify message DONE
698
699 cd $PWD
700 }
701
702 ipfirepackages() {
703 ipfiremake core-updates
704 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
705 if [ -e $BASEDIR/lfs/$i ]; then
706 ipfiredist $i
707 else
708 echo -n $i
709 beautify message SKIP
710 fi
711 done
712 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
713 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
714 rm -rf $BASEDIR/build/install/packages/*
715 }
716
717 # See what we're supposed to do
718 case "$1" in
719 build)
720 clear
721 BUILDMACHINE=`uname -m`
722 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
723 #only restore on a clean disk
724 if [ ! -f log/cleanup-toolchain-2-tools ]; then
725 if [ ! -n "$PACKAGE" ]; then
726 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
727 prepareenv
728 buildtoolchain
729 else
730 PACKAGENAME=${PACKAGE%.tar.gz}
731 beautify build_stage "Packaged toolchain compilation"
732 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
733 tar zxf $PACKAGE
734 prepareenv
735 else
736 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
737 fi
738 fi
739 else
740 echo -n "Using installed toolchain" | tee -a $LOGFILE
741 beautify message SKIP
742 prepareenv
743 fi
744
745 beautify build_start
746 beautify build_stage "Building LFS"
747 buildbase
748
749 beautify build_stage "Building IPFire"
750 buildipfire
751
752 beautify build_stage "Building installer"
753 buildinstaller
754
755 beautify build_stage "Building packages"
756 buildpackages
757 beautify build_end
758 ;;
759 shell)
760 # enter a shell inside LFS chroot
761 # may be used to changed kernel settings
762 prepareenv
763 entershell
764 ;;
765 clean)
766 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
767 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
768 $LOSETUP -d $i 2>/dev/null
769 done
770 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
771 umount $i
772 done
773 stdumount
774 for i in `seq 0 7`; do
775 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
776 umount /dev/loop${i} 2>/dev/null;
777 losetup -d /dev/loop${i} 2>/dev/null;
778 fi;
779 done
780 rm -rf $BASEDIR/build
781 rm -rf $BASEDIR/cdrom
782 rm -rf $BASEDIR/packages
783 rm -rf $BASEDIR/log
784 if [ -h /tools ]; then
785 rm -f /tools
786 fi
787 beautify message DONE
788 ;;
789 downloadsrc)
790 if [ ! -d $BASEDIR/cache ]; then
791 mkdir $BASEDIR/cache
792 fi
793 mkdir -p $BASEDIR/log
794 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
795 FINISHED=0
796 cd $BASEDIR/lfs
797 for c in `seq $MAX_RETRIES`; do
798 if (( FINISHED==1 )); then
799 break
800 fi
801 FINISHED=1
802 cd $BASEDIR/lfs
803 for i in *; do
804 if [ -f "$i" -a "$i" != "Config" ]; then
805 echo -ne "Loading $i"
806 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
807 if [ $? -ne 0 ]; then
808 beautify message FAIL
809 FINISHED=0
810 else
811 if [ $c -eq 1 ]; then
812 beautify message DONE
813 fi
814 fi
815 fi
816 done
817 done
818 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
819 ERROR=0
820 for i in *; do
821 if [ -f "$i" -a "$i" != "Config" ]; then
822 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
823 if [ $? -ne 0 ]; then
824 echo -ne "MD5 difference in lfs/$i"
825 beautify message FAIL
826 ERROR=1
827 fi
828 fi
829 done
830 if [ $ERROR -eq 0 ]; then
831 echo -ne "${BOLD}all files md5sum match${NORMAL}"
832 beautify message DONE
833 else
834 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
835 beautify message FAIL
836 fi
837 cd - >/dev/null 2>&1
838 ;;
839 toolchain)
840 clear
841 prepareenv
842 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
843 buildtoolchain
844 BUILDMACHINE=`uname -m`
845 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
846 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
847 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
848 build/{bin,etc,usr/bin,usr/local} \
849 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
850 log >> $LOGFILE
851 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
852 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
853 stdumount
854 ;;
855 gettoolchain)
856 BUILDMACHINE=`uname -m`
857 # arbitrary name to be updated in case of new toolchain package upload
858 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
859 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
860 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
861 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
862 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
863 cd $BASEDIR/cache/toolchains
864 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
865 if [ $? -ne 0 ]; then
866 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
867 else
868 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
869 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
870 else
871 exiterror "$PACKAGE.md5 did not match, check downloaded package"
872 fi
873 fi
874 else
875 echo "Toolchain is already downloaded. Exiting..."
876 fi
877 ;;
878 othersrc)
879 prepareenv
880 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
881 chroot $LFS /tools/bin/env -i HOME=/root \
882 TERM=$TERM PS1='\u:\w\$ ' \
883 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
884 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
885 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
886 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
887 if [ $? -eq "0" ]; then
888 beautify message DONE
889 else
890 beautify message FAIL
891 fi
892 stdumount
893 ;;
894 git)
895 case "$2" in
896 update|up)
897 git pull
898 ;;
899 commit|ci)
900 shift 2
901 git commit $*
902
903 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
904
905 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
906 read
907 [ -z $REPLY ] && exit 0
908 for i in y Y j J; do
909 if [ "$i" == "$REPLY" ]; then
910 $0 git push
911 exit $?
912 fi
913 done
914 exiterror "\"$REPLY\" is not a valid answer."
915 ;;
916 dist)
917 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
918 ;;
919 diff|di)
920 echo -ne "Make a local diff to last revision"
921 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
922 evaluate 1
923 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
924 git diff --stat
925 ;;
926 push)
927 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
928 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
929
930 git push ${GIT_URL} ${GIT_BRANCH}
931 ;;
932 log)
933 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
934 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
935
936 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
937 ;;
938 esac
939 ;;
940 uploadsrc)
941 PWD=`pwd`
942 cd $BASEDIR/cache/
943 echo -e "Uploading cache to ftp server:"
944 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
945 for i in *; do
946 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
947 grep -q $(basename $i) /tmp/ftplist
948 if [ "$?" -ne "0" ]; then
949 echo -ne "$(basename $i)"
950 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
951 if [ "$?" -ne "0" ]; then
952 beautify message FAIL
953 fi
954 fi
955 done
956 rm -f /tmp/ftplist
957 cd $PWD
958 exit 0
959 ;;
960 upload)
961 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
962 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
963 if [ -z $FTP_ISO_PORT ]; then
964 FTP_ISO_PORT=21
965 fi
966 cat <<EOF > .ftp-commands
967 mkdir -p $FTP_ISO_PATH$SVN_REVISION
968 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
969 quit
970 EOF
971 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
972 rm -f .ftp-commands
973
974 case "$2" in
975 iso)
976 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
977
978 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
979 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
980 if [ -e "$i" ]; then
981 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
982 if [ "$?" -eq "0" ]; then
983 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
984 else
985 echo "There was an error while uploading the file $i to the ftp server."
986 exit 1
987 fi
988 fi
989 done
990 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
991 if [ "$3" = "--with-sources-cd" ]; then
992 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
993 fi
994 ;;
995 paks)
996 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
997 if [ "$?" -eq "0" ]; then
998 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
999 else
1000 echo -e "There was an error while uploading the packages to the ftp server."
1001 exit 1
1002 fi
1003 ;;
1004 esac
1005 ;;
1006 batch)
1007 if [ "$2" = "--background" ]; then
1008 batch_script
1009 exit $?
1010 fi
1011 if [ `screen -ls | grep -q ipfire` ]; then
1012 echo "Build is already running, sorry!"
1013 exit 1
1014 else
1015 if [ "$2" = "--rebuild" ]; then
1016 export IPFIRE_REBUILD=1
1017 echo "REBUILD!"
1018 else
1019 export IPFIRE_REBUILD=0
1020 fi
1021 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1022 screen -dmS ipfire $0 batch --background
1023 evaluate 1
1024 exit 0
1025 fi
1026 ;;
1027 watch)
1028 watch_screen
1029 ;;
1030 pxe)
1031 case "$2" in
1032 start)
1033 start_tftpd
1034 ;;
1035 stop)
1036 stop_tftpd
1037 ;;
1038 reload|restart)
1039 reload_tftpd
1040 ;;
1041 esac
1042 exit 0
1043 ;;
1044 lang)
1045 update_langs
1046 ;;
1047 "")
1048 clear
1049 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1050 do
1051 case $name in
1052 "IPFIRE: Downloadsrc")
1053 $0 downloadsrc
1054 ;;
1055 "IPFIRE: Build (silent)")
1056 $0 build-silent
1057 ;;
1058 "IPFIRE: Watch Build")
1059 $0 watch
1060 ;;
1061 "IPFIRE: Batch")
1062 $0 batch
1063 ;;
1064 "IPFIRE: Clean")
1065 $0 clean
1066 ;;
1067 "Help")
1068 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1069 cat doc/make.sh-usage
1070 ;;
1071 "LOG: Tail")
1072 tail -f log/_*
1073 ;;
1074 "Exit")
1075 break
1076 ;;
1077 esac
1078 done
1079 ;;
1080 config)
1081 make_config
1082 ;;
1083 *)
1084 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1085 cat doc/make.sh-usage
1086 ;;
1087 esac